package net.tekiton.minesweeper;

import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.swing.border.*;

@SuppressWarnings("serial")
public class Minesweeper_bak extends JFrame{

	final int FIELD_WIDTH;
	final int FIELD_HEIGHT;
	final int FIELD_SIZE;
	final int FIELD_BUTTON_SIZE;
	static int[] field = null;
	static JButton[] fieldButton = null;
	static JButton refreshButton = new JButton(new ImageIcon("./icon/face-smile.png"));


	public static void main(String[] args) {
		Minesweeper_bak frame = new Minesweeper_bak(20,15);
		frame.setVisible(true);
	}


	Minesweeper_bak(int width, int height){
		this(width, height, 16);
	}

	Minesweeper_bak(int width, int height, int buttonSize){
		FIELD_WIDTH = width;
		FIELD_HEIGHT = height;
		FIELD_SIZE = width * height;
		FIELD_BUTTON_SIZE = buttonSize;

		field = new int[FIELD_SIZE];
		fieldButton = new JButton[FIELD_SIZE];

		setTitle("Minesweeper");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(200, 700, 300, 300);
		setResizable(false);
		setVisual();

		getContentPane().add(mainPane(), BorderLayout.CENTER);
		pack();
	}


	JPanel mainPane(){

		JPanel containerPane = new JPanel();
		containerPane.setLayout(new BorderLayout());
		containerPane.setOpaque(false);
		{

			JToolBar toolbar = new JToolBar();
			toolbar.setLayout(new BoxLayout(toolbar, BoxLayout.X_AXIS));
			toolbar.setBorder(new EmptyBorder(5,5,5,5));
			toolbar.setFloatable(false);
			{
				JLabel quantityField = new JLabel("000");
				quantityField.setFont(new Font("sansserif", Font.PLAIN, 20));
				quantityField.setHorizontalAlignment(JTextField.CENTER);
				quantityField.setPreferredSize(new Dimension(50,30));
				quantityField.setOpaque(true);
				quantityField.setForeground(Color.RED);
				quantityField.setBackground(Color.BLACK);
				quantityField.setBorder(new BevelBorder(BevelBorder.RAISED, Color.GRAY, Color.WHITE));
				toolbar.add(quantityField);

				toolbar.add(Box.createGlue());

				refreshButton.setToolTipText("リセット");
				refreshButton.setActionCommand("refresh");
				refreshButton.addActionListener(new MineActionListener());
				toolbar.add(refreshButton);

				toolbar.add(Box.createGlue());

				JLabel timeField = new JLabel("000");
				timeField.setFont(new Font("sansserif", Font.PLAIN, 20));
				timeField.setHorizontalAlignment(JTextField.CENTER);
				timeField.setPreferredSize(new Dimension(50,30));
				timeField.setOpaque(true);
				timeField.setForeground(Color.RED);
				timeField.setBackground(Color.BLACK);
				timeField.setBorder(new BevelBorder(BevelBorder.RAISED, Color.GRAY, Color.WHITE));
				toolbar.add(timeField);

			}
			containerPane.add(toolbar, BorderLayout.NORTH);

			JPanel mainPane = new JPanel();
			mainPane.setLayout(new BoxLayout(mainPane,BoxLayout.Y_AXIS));
			mainPane.setOpaque(false);
			{
				JPanel fieldPane = new JPanel();
				Dimension fieldPaneSize = new Dimension(FIELD_WIDTH*FIELD_BUTTON_SIZE, FIELD_HEIGHT*FIELD_BUTTON_SIZE);

				fieldPane.setSize(fieldPaneSize);
				fieldPane.setPreferredSize(fieldPaneSize);
				fieldPane.setMaximumSize(fieldPaneSize);
				fieldPane.setMinimumSize(fieldPaneSize);
				fieldPane.setLayout(new GridLayout(FIELD_HEIGHT,FIELD_WIDTH));
				{
					for(int i=0;i<fieldButton.length;i++){
						fieldButton[i] = new JButton();
						fieldButton[i].setHorizontalAlignment(JLabel.LEFT);
						fieldButton[i].setVerticalAlignment(JLabel.TOP);
						fieldButton[i].setMargin(new Insets(0, 0, 0, 0));
						fieldButton[i].setName("btn"+i);
						fieldButton[i].setActionCommand("btn"+i);
						fieldButton[i].addMouseListener(new MineMouseListener());
						fieldButton[i].addActionListener(new MineActionListener());
						fieldButton[i].setFocusPainted(false);

						fieldPane.add(fieldButton[i]);
					}
				}
				mainPane.add(fieldPane);
			}
			containerPane.add(mainPane, BorderLayout.CENTER);
		}

		return containerPane;

	}


	static void resetField(){

		for(int i=0;i<field.length;i++){

			field[i] = 0;
			fieldButton[i].setEnabled(true);
			fieldButton[i].setBorder((Border) UIManager.getDefaults().get("Button.border"));
			fieldButton[i].setBackground((Color) UIManager.getDefaults().get("Button.background"));

		}

	}

	static void createField(){

		for(int i=0;i<field.length;i++){

		}

	}


	void setVisual(){

		try{
			UIManager.setLookAndFeel(new MyLookAndFeel());
			SwingUtilities.updateComponentTreeUI(this);
		}catch(Exception e){
			e.printStackTrace();
		}

		 Font font = new Font("MS UI Gothic",Font.PLAIN,12);
		 LookAndFeel laf = UIManager.getLookAndFeel();
		 Set<Object> keys = laf.getDefaults().keySet();
		 for (Iterator<Object> it = keys.iterator(); it.hasNext();) {
			String key=it.next().toString();
			if (key.indexOf("font") != -1) {
				UIManager.put(key, font);
			}
		 }

	}

}
